# swagger_client.CompanyApi

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_company**](CompanyApi.md#get_company) | **GET** /companies | get the details of a company
[**update_company**](CompanyApi.md#update_company) | **PATCH** /companies/{id} | update the Company


# **get_company**
> CompanyResponse get_company()

get the details of a company

get the details of a company

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.CompanyApi()

try: 
    # get the details of a company
    api_response = api_instance.get_company()
    pprint(api_response)
except ApiException as e:
    print "Exception when calling CompanyApi->get_company: %s\n" % e
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**CompanyResponse**](CompanyResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_company**
> PatchResponse update_company(id, company)

update the Company

update the Company

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.CompanyApi()
id = 'id_example' # str | the id of the Company
company = swagger_client.CompanyPatch() # CompanyPatch | the data to update

try: 
    # update the Company
    api_response = api_instance.update_company(id, company)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling CompanyApi->update_company: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the Company | 
 **company** | [**CompanyPatch**](CompanyPatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

