# swagger_client.NewsletterApi

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**create_newsletter**](NewsletterApi.md#create_newsletter) | **POST** /lists/{lid}/newsletters | creates a new newsletter
[**get_newsletter**](NewsletterApi.md#get_newsletter) | **GET** /newsletters/{id} | get one newsletter
[**get_newsletters**](NewsletterApi.md#get_newsletters) | **GET** /lists/{lid}/newsletters | get all newsletters of the given list
[**get_reports**](NewsletterApi.md#get_reports) | **GET** /lists/{lid}/newsletters/{nid}/aggregations | get reports for the newsletter aggregated by days
[**send_newsletter**](NewsletterApi.md#send_newsletter) | **POST** /newsletters/{id}/send | Sends the newsletter to a list or group
[**update_newsletter**](NewsletterApi.md#update_newsletter) | **PATCH** /newsletters/{id} | update the Newsletter


# **create_newsletter**
> ApiResponsePost create_newsletter(lid, newsletter)

creates a new newsletter

creates a new Newsletter

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.NewsletterApi()
lid = 'lid_example' # str | the id of the list
newsletter = swagger_client.NewsletterPost() # NewsletterPost | the data to save

try: 
    # creates a new newsletter
    api_response = api_instance.create_newsletter(lid, newsletter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling NewsletterApi->create_newsletter: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **newsletter** | [**NewsletterPost**](NewsletterPost.md)| the data to save | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_newsletter**
> NewsletterResponse get_newsletter(id, filter=filter, fields=fields)

get one newsletter

get Newsletter

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.NewsletterApi()
id = 'id_example' # str | the id of the newsletter
filter = 'filter_example' # str | a FIQL-Filter (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get one newsletter
    api_response = api_instance.get_newsletter(id, filter=filter, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling NewsletterApi->get_newsletter: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the newsletter | 
 **filter** | **str**| a FIQL-Filter | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**NewsletterResponse**](NewsletterResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_newsletters**
> NewsletterResponse get_newsletters(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get all newsletters of the given list

get Newsletters

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.NewsletterApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get all newsletters of the given list
    api_response = api_instance.get_newsletters(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling NewsletterApi->get_newsletters: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**NewsletterResponse**](NewsletterResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_reports**
> ReportResponse get_reports(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get reports for the newsletter aggregated by days

get reports for the newsletter aggregated by days

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.NewsletterApi()
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get reports for the newsletter aggregated by days
    api_response = api_instance.get_reports(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling NewsletterApi->get_reports: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**ReportResponse**](ReportResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **send_newsletter**
> send_newsletter(id, newsletter)

Sends the newsletter to a list or group



### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.NewsletterApi()
id = 'id_example' # str | the id of the list
newsletter = swagger_client.NewsletterSend() # NewsletterSend | the data to save

try: 
    # Sends the newsletter to a list or group
    api_instance.send_newsletter(id, newsletter)
except ApiException as e:
    print "Exception when calling NewsletterApi->send_newsletter: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the list | 
 **newsletter** | [**NewsletterSend**](NewsletterSend.md)| the data to save | 

### Return type

void (empty response body)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_newsletter**
> PatchResponse update_newsletter(id, newsletter)

update the Newsletter

update one Newsletter

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.NewsletterApi()
id = 'id_example' # str | the id of the newsletter
newsletter = swagger_client.NewsletterPost() # NewsletterPost | the data to update

try: 
    # update the Newsletter
    api_response = api_instance.update_newsletter(id, newsletter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling NewsletterApi->update_newsletter: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the newsletter | 
 **newsletter** | [**NewsletterPost**](NewsletterPost.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

