# swagger_client.RecipientApi

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**add_recipient_to_group**](RecipientApi.md#add_recipient_to_group) | **POST** /lists/{lid}/groups/{gid}/recipients/{id} | add single recipient to group
[**add_recipients_to_group**](RecipientApi.md#add_recipients_to_group) | **POST** /lists/{lid}/groups/{gid}/recipients | add all Recipients to the given group
[**create_recipient**](RecipientApi.md#create_recipient) | **POST** /recipients | create new recipient(s) or updates existing ones
[**delete_recipient**](RecipientApi.md#delete_recipient) | **DELETE** /lists/{lid}/recipients/{id} | delete the recipient
[**get_recipients**](RecipientApi.md#get_recipients) | **GET** /lists/{lid}/recipients | get all Recipients of selected list
[**get_recipients_by_group**](RecipientApi.md#get_recipients_by_group) | **GET** /lists/{lid}/groups/{gid}/recipients | get all Recipients of selected group
[**import_recipients_init**](RecipientApi.md#import_recipients_init) | **POST** /lists/{lid}/recipients/import/init | Initialize the import of recipients by file
[**import_recipients_save**](RecipientApi.md#import_recipients_save) | **POST** /lists/{lid}/recipients/import/save | Start the import recipients by file
[**import_recipients_statistics**](RecipientApi.md#import_recipients_statistics) | **GET** /import/{id}/info | Get statistics about the import by file
[**remove_recipient_from_group**](RecipientApi.md#remove_recipient_from_group) | **DELETE** /lists/{lid}/groups/{gid}/recipients/{id} | remove single recipient from group
[**remove_recipients_from_group**](RecipientApi.md#remove_recipients_from_group) | **DELETE** /lists/{lid}/groups/{gid}/recipients | remove all Recipients from given group
[**remove_recipients_from_list**](RecipientApi.md#remove_recipients_from_list) | **DELETE** /lists/{lid}/recipients | remove all Recipients from selected list
[**subscribe_recipient**](RecipientApi.md#subscribe_recipient) | **POST** /forms/submit/{code} | Creates a new recipient and sends a DOI-Mail
[**update_recipient**](RecipientApi.md#update_recipient) | **PATCH** /lists/{lid}/recipients/{id} | update the recipient.
[**update_recipients**](RecipientApi.md#update_recipients) | **PATCH** /lists/{lid}/recipients | update all Recipients in selected list


# **add_recipient_to_group**
> PatchResponse add_recipient_to_group(lid, gid, id)

add single recipient to group

add Recipient to Group

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
gid = 'gid_example' # str | the id of the group
id = 'id_example' # str | the id of the recipient

try: 
    # add single recipient to group
    api_response = api_instance.add_recipient_to_group(lid, gid, id)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->add_recipient_to_group: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **gid** | **str**| the id of the group | 
 **id** | **str**| the id of the recipient | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **add_recipients_to_group**
> PatchResponse add_recipients_to_group(lid, gid, filter=filter)

add all Recipients to the given group

add all Recipients to the given group. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting added to the group!

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
gid = 'gid_example' # str | the id of the group
filter = 'filter_example' # str | a FIQL-Filter (optional)

try: 
    # add all Recipients to the given group
    api_response = api_instance.add_recipients_to_group(lid, gid, filter=filter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->add_recipients_to_group: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **gid** | **str**| the id of the group | 
 **filter** | **str**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **create_recipient**
> ApiResponsePost create_recipient(recipient)

create new recipient(s) or updates existing ones

create new recipient(s).<br>If a custom attribute shall by saved for the new recipient just submit them in the json body by name.<br>If <b>multiple recipients</b> shall by saved at once, submit multiple recipient-objects as a json array.<br><b>In this case all objects must share the same attributes.</b><br/>If the e-mail-address exists already the existing recipient gets updated.

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
recipient = swagger_client.RecipientPost() # RecipientPost | the data to save

try: 
    # create new recipient(s) or updates existing ones
    api_response = api_instance.create_recipient(recipient)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->create_recipient: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **recipient** | [**RecipientPost**](RecipientPost.md)| the data to save | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **delete_recipient**
> ApiResponseDelete delete_recipient(lid, id)

delete the recipient

delete one recipient

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
id = 'id_example' # str | the id of the recipient

try: 
    # delete the recipient
    api_response = api_instance.delete_recipient(lid, id)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->delete_recipient: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **id** | **str**| the id of the recipient | 

### Return type

[**ApiResponseDelete**](ApiResponseDelete.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_recipients**
> RecipientResponse get_recipients(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get all Recipients of selected list

Get Recipients. If the API shall return custom attributes also, submit them in the _fields-Parameter by name.

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get all Recipients of selected list
    api_response = api_instance.get_recipients(lid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->get_recipients: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**RecipientResponse**](RecipientResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **get_recipients_by_group**
> RecipientResponse get_recipients_by_group(lid, gid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get all Recipients of selected group

get Recipients

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
gid = 'gid_example' # str | the id of the group
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get all Recipients of selected group
    api_response = api_instance.get_recipients_by_group(lid, gid, filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->get_recipients_by_group: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **gid** | **str**| the id of the group | 
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**RecipientResponse**](RecipientResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **import_recipients_init**
> InlineResponse200 import_recipients_init(lid, file)

Initialize the import of recipients by file

Initialize the import recipients by file

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
file = '/path/to/file.txt' # file | recipient file to upload

try: 
    # Initialize the import of recipients by file
    api_response = api_instance.import_recipients_init(lid, file)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->import_recipients_init: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **file** | **file**| recipient file to upload | 

### Return type

[**InlineResponse200**](InlineResponse200.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: multipart/form-data
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **import_recipients_save**
> ApiResponsePost import_recipients_save(lid, data)

Start the import recipients by file

Start the import recipients by file. The returned id can be used to fetch further statistics about the import.

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
data = swagger_client.Data() # Data | the data to start the import

try: 
    # Start the import recipients by file
    api_response = api_instance.import_recipients_save(lid, data)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->import_recipients_save: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **data** | [**Data**](Data.md)| the data to start the import | 

### Return type

[**ApiResponsePost**](ApiResponsePost.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **import_recipients_statistics**
> ImportResponse import_recipients_statistics(id)

Get statistics about the import by file

Get statistics about the import by file.

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
id = 'id_example' # str | the id of the import job

try: 
    # Get statistics about the import by file
    api_response = api_instance.import_recipients_statistics(id)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->import_recipients_statistics: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the import job | 

### Return type

[**ImportResponse**](ImportResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_recipient_from_group**
> PatchResponse remove_recipient_from_group(lid, gid, id)

remove single recipient from group

remove Recipient to Group

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
gid = 'gid_example' # str | the id of the group
id = 'id_example' # str | the id of the recipient

try: 
    # remove single recipient from group
    api_response = api_instance.remove_recipient_from_group(lid, gid, id)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->remove_recipient_from_group: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **gid** | **str**| the id of the group | 
 **id** | **str**| the id of the recipient | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_recipients_from_group**
> PatchResponse remove_recipients_from_group(lid, gid, filter=filter)

remove all Recipients from given group

remove all Recipients from given group. Pay attention to the filter, if you forget to submit it, all recipients are getting removed from the group!

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
gid = 'gid_example' # str | the id of the group
filter = 'filter_example' # str | a FIQL-Filter (optional)

try: 
    # remove all Recipients from given group
    api_response = api_instance.remove_recipients_from_group(lid, gid, filter=filter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->remove_recipients_from_group: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **gid** | **str**| the id of the group | 
 **filter** | **str**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **remove_recipients_from_list**
> PatchResponse remove_recipients_from_list(lid, filter=filter)

remove all Recipients from selected list

remove Recipients from selected list. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting removed!

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)

try: 
    # remove all Recipients from selected list
    api_response = api_instance.remove_recipients_from_list(lid, filter=filter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->remove_recipients_from_list: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **subscribe_recipient**
> RecipientSubscribeResponse subscribe_recipient(code, recipient)

Creates a new recipient and sends a DOI-Mail

Creates a new recipient and sends the corresponding DOI-Mail attached to the previously created subscribe-form. The recipient will be available as soon as the recipient has confirmed the DOI-Mail.

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
code = 'code_example' # str | the subscribe-code displayed when creating a subscribe-form
recipient = swagger_client.RecipientSubscribe() # RecipientSubscribe | the recipient to subscribe

try: 
    # Creates a new recipient and sends a DOI-Mail
    api_response = api_instance.subscribe_recipient(code, recipient)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->subscribe_recipient: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **code** | **str**| the subscribe-code displayed when creating a subscribe-form | 
 **recipient** | [**RecipientSubscribe**](RecipientSubscribe.md)| the recipient to subscribe | 

### Return type

[**RecipientSubscribeResponse**](RecipientSubscribeResponse.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_recipient**
> PatchResponse update_recipient(lid, id, recipient)

update the recipient.

update one Recipient. If a value of a custom attribute shall by changed just submit it in the json body

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
id = 'id_example' # str | the id of the recipient
recipient = swagger_client.RecipientPatch() # RecipientPatch | the data to update

try: 
    # update the recipient.
    api_response = api_instance.update_recipient(lid, id, recipient)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->update_recipient: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **id** | **str**| the id of the recipient | 
 **recipient** | [**RecipientPatch**](RecipientPatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_recipients**
> PatchResponse update_recipients(lid, filter=filter)

update all Recipients in selected list

Updates all recipients in the given list where the filter applies. If a value of a custom attribute shall by changed just submit it in the json body. Pay attention to the filter, if you forget to submit it, all recipients of the current list are getting updated!

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.RecipientApi()
lid = 'lid_example' # str | the id of the list
filter = 'filter_example' # str | a FIQL-Filter (optional)

try: 
    # update all Recipients in selected list
    api_response = api_instance.update_recipients(lid, filter=filter)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling RecipientApi->update_recipients: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **lid** | **str**| the id of the list | 
 **filter** | **str**| a FIQL-Filter | [optional] 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

