# swagger_client.ReportApi

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_reports**](ReportApi.md#get_reports) | **GET** /lists/{lid}/newsletters/{nid}/aggregations | get reports for the newsletter aggregated by days


# **get_reports**
> ReportResponse get_reports(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get reports for the newsletter aggregated by days

get reports for the newsletter aggregated by days

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.ReportApi()
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get reports for the newsletter aggregated by days
    api_response = api_instance.get_reports(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling ReportApi->get_reports: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**ReportResponse**](ReportResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

