# swagger_client.UserApi

All URIs are relative to *https://api.newsletter2go.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**get_users**](UserApi.md#get_users) | **GET** /users | get all users of the company where the current user has access to
[**update_user**](UserApi.md#update_user) | **PATCH** /users/{id} | update the user


# **get_users**
> UserResponse get_users(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)

get all users of the company where the current user has access to

get Users

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.UserApi()
filter = 'filter_example' # str | a FIQL-Filter (optional)
limit = 50 # int | a limit for list-responses (optional) (default to 50)
offset = 0 # int | an offset for list-responses (optional) (default to 0)
expand = true # bool | true if attributes should be returned or not (optional)
fields = ['fields_example'] # list[str] | list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed (optional)

try: 
    # get all users of the company where the current user has access to
    api_response = api_instance.get_users(filter=filter, limit=limit, offset=offset, expand=expand, fields=fields)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling UserApi->get_users: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **filter** | **str**| a FIQL-Filter | [optional] 
 **limit** | **int**| a limit for list-responses | [optional] [default to 50]
 **offset** | **int**| an offset for list-responses | [optional] [default to 0]
 **expand** | **bool**| true if attributes should be returned or not | [optional] 
 **fields** | [**list[str]**](str.md)| list of case-sensetive fields which should be returned.    Only needed if _expand is false or special attributes are needed | [optional] 

### Return type

[**UserResponse**](UserResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

# **update_user**
> PatchResponse update_user(id, user)

update the user

update one user

### Example 
```python
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: OAuth
swagger_client.configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.UserApi()
id = 'id_example' # str | the id of the user
user = swagger_client.UserPatch() # UserPatch | the data to update

try: 
    # update the user
    api_response = api_instance.update_user(id, user)
    pprint(api_response)
except ApiException as e:
    print "Exception when calling UserApi->update_user: %s\n" % e
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **str**| the id of the user | 
 **user** | [**UserPatch**](UserPatch.md)| the data to update | 

### Return type

[**PatchResponse**](PatchResponse.md)

### Authorization

[OAuth](../README.md#OAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

[[Back to top]](#) [[Back to API list]](../README.md#documentation-for-api-endpoints) [[Back to Model list]](../README.md#documentation-for-models) [[Back to README]](../README.md)

