# coding: utf-8

"""
    Newsletter2Go-API (https://api.newsletter2go.com)

    <h5>JSON first</h5><br/>Our REST API exchanges data in the JSON data format. Every parameter you pass (with a few exceptions e.g. when you upload files) should therefore be formatted in JSON and our API will always return results in JSON as well.<br/><br/><h5>Very RESTful</h5><br/>Our API follows a very RESTful approach.<br/>Most importantly, we implemented the following four request methods for CRUD operations:<br/><br/>POST - Create a new record<br/>GET - Retrieve / read records without changing anything<br/>PATCH - Update an existing record<br/>DELETE - Delete one or more records<br/><br/><h5>HTTP Status codes</h5><br/>We also follow the most common HTTP status codes when outputting the API response:<br/><br/><b>2xx - Successful calls</b><br/>200 - Success<br/>201 - Created<br/><br/><b>4xx - Error codes</b><br/>400 - API error - inspect the body for detailed information about what went wrong. The most common error is \"code\":1062, which means, that a unique constraint was hit. For example if the name of the group is already in use.<br/>401 - Not authenticated - invalid access_token. Check if the access_token has expired or is incorrect.<br/>403 - Access denied<br/>404 - Call not available or no records found<br/><br/><b>5xx - API error - please contact support</b><br/><br/><h5>Response format</h5><br/>The API always returns data in the following format<br/><br/><code>{<br/>&nbsp;&nbsp;\"info\": {<br/>&nbsp;&nbsp;&nbsp;&nbsp;\"count\": 0<br/>&nbsp;&nbsp;},<br/>&nbsp;&nbsp;\"value\": [<br/>&nbsp;&nbsp;&nbsp;{<br/>&nbsp;&nbsp;&nbsp;&nbsp;\"key\": \"value\"<br/>&nbsp;&nbsp;&nbsp;}<br/>&nbsp;&nbsp;]<br/>}</code><br/><br/><h5>Recurring GET parameters</h5><br/><ul><li>_filter - a complex filter for filtering the result set based on <a target=\"blank\" href=\"https://tools.ietf.org/html/draft-nottingham-atompub-fiql-00\">FIQL</a>.</li><li>_limit - the maximum number records returned.</li><li>_offset - pagination for the result-set</li><li>_expand - submit true to get all default fields of the resource</li><li>_fields - submit a comma-separated list of case-sensetive field-names to get the values of these fields in the response. You can use this the get values of custom attribute of recipients for example.</li></ul><br/><br/><h5>Filter language</h5><br/>The filter language for filtering results is based on <a target=\"blank\" href=\"https://tools.ietf.org/html/draft-nottingham-atompub-fiql-00\">FIQL</a>.<br/>With the only restriction, that plain values must be surrounded by \". For example first_name==\"Max\"<br/>The following operators are supported<ul><li>Equals - <b>==</b></li><li>Not equals - <b>=ne=</b></li><li>Greater than - <b>=gt=</b></li><li>Greater than equals - <b>=ge=</b></li><li>Lower than - <b>=lt=</b></li><li>Lower than equals - <b>=le=</b></li><li>Like - <b>=like=</b> (in combination with % you are able to search for <i>starts with</i>, <i>ends with</i>, <i>contains</i>. For example first_name=like=\"%Max%\")</li><li>Not like - <b>=nlike=</b></li><li>Logical and - <b>;</b></li><li>Logical or - <b>,</b></li></ul><br/><br/><h5>How to make Calls?</h5><br/>After you authenticated and received a valid access_token, you have to pass it in every consecutive call. Use the Authorization header for that purpose as follows:<br/><code>xhr.setRequestHeader(\"Authorization\", \"Bearer \" + your_access_token);</code><br/><br/>Every call takes additional parameters that can be used to modify the request. These parameters should be passed as JSON<br/><code>var params = {<br/>&nbsp;&nbsp;\"key\"= \"value\"<br/>}<br/>xhr.send(JSON.stringify(params));</code><br/><br/><h5>Sending transactional emails</h5><br/>It is very important to understand the following concept in order for you to take full advantage of our powerful personalization features and our detailed reports when sending transactional emails.<br/><br/>First, you will have to create a new mailing. We recommend that you create that mailing through our UI in order to take full advantage of our powerful newsletter builder. This way, we will automatically create cross-client optimized and responsive HTML. Yet another advantage lies in the possibility for other users (e.g. the marketing team) to change the layout or the content of the mailing without having to contact the developer (you).<br/><br/>Of course, it is also possible to create a mailing through the API. When doing so, you can also take advantage of our cross-client optimized responsive HTML by passing us JSON or YAML according to the Newsletter2Go Markup Language.<br/>No matter how you create the mailing, try to create *one* reusable template. You can customize individual emails by inserting placeholders for personalized fields such as name, products or other information that will be filled through an API call when sending.<br/><br/>By only creating one template, you can take advantage of our full reporting since all emails will be treated part of a \"campaign\". When you change that template, we will create a new version of the mailing in the background and you will be able to see the difference in performance in the reports. This is particularily useful when you are trying to test and optimize different versions of transactional emails such as a sign up email.<br/><br/>After creating a mailing, you will have access to its ID. Use that ID to actually send the email in the next step.<br/><br/>When sending an email, you have to pass the newsletter ID and information about the recipient. Either pass the recipient ID or pass all the recipient's data (including the e-mail-address) as JSON.<br/><br/>If you only pass the recipient ID, we will use his or her data from your list to personalize the mailing. If you pass full recipient data as JSON, we will try to merge the data with existing data from your list.<br/><br/>You can also pass additional data such as product data which is not saved in your list. Just make sure that the placeholders in the source of the mailing correspond to the parameters that you are passing.<br/>This way you can also create for-loops which can be useful if you pass different amounts of data for each recipient (e.g. a purchase confirmation where you want to list all the products that were just bought).

    OpenAPI spec version: 1.0.0
    Contact: support@newsletter2go.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
    
    Licensed under the Apache License, Version 2.0 (the "License");
    you may not use this file except in compliance with the License.
    You may obtain a copy of the License at
    
        http://www.apache.org/licenses/LICENSE-2.0
    
    Unless required by applicable law or agreed to in writing, software
    distributed under the License is distributed on an "AS IS" BASIS,
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    See the License for the specific language governing permissions and
    limitations under the License.
"""

from pprint import pformat
from six import iteritems
import re


class Report(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self):
        """
        Report - a model defined in Swagger

        :param dict swaggerTypes: The key is attribute name
                                  and the value is attribute type.
        :param dict attributeMap: The key is attribute name
                                  and the value is json key in definition.
        """
        self.swagger_types = {
            'newsletter_id': 'str',
            'date': 'date',
            'mail_count': 'int',
            'opens': 'int',
            'unique_opens': 'int',
            'clicks': 'int',
            'unique_clicks': 'int',
            'conversions': 'int',
            'sum_conversions': 'int',
            'unsubscribes': 'int',
            'hard_bounces': 'int',
            'soft_bounces': 'int',
            'spam_bounces': 'int'
        }

        self.attribute_map = {
            'newsletter_id': 'newsletter_id',
            'date': 'date',
            'mail_count': 'mail_count',
            'opens': 'opens',
            'unique_opens': 'unique_opens',
            'clicks': 'clicks',
            'unique_clicks': 'unique_clicks',
            'conversions': 'conversions',
            'sum_conversions': 'sum_conversions',
            'unsubscribes': 'unsubscribes',
            'hard_bounces': 'hard_bounces',
            'soft_bounces': 'soft_bounces',
            'spam_bounces': 'spam_bounces'
        }

        self._newsletter_id = None
        self._date = None
        self._mail_count = None
        self._opens = None
        self._unique_opens = None
        self._clicks = None
        self._unique_clicks = None
        self._conversions = None
        self._sum_conversions = None
        self._unsubscribes = None
        self._hard_bounces = None
        self._soft_bounces = None
        self._spam_bounces = None

    @property
    def newsletter_id(self):
        """
        Gets the newsletter_id of this Report.
        the id of the newsletter

        :return: The newsletter_id of this Report.
        :rtype: str
        """
        return self._newsletter_id

    @newsletter_id.setter
    def newsletter_id(self, newsletter_id):
        """
        Sets the newsletter_id of this Report.
        the id of the newsletter

        :param newsletter_id: The newsletter_id of this Report.
        :type: str
        """
        
        self._newsletter_id = newsletter_id

    @property
    def date(self):
        """
        Gets the date of this Report.
        the date of the aggregation

        :return: The date of this Report.
        :rtype: date
        """
        return self._date

    @date.setter
    def date(self, date):
        """
        Sets the date of this Report.
        the date of the aggregation

        :param date: The date of this Report.
        :type: date
        """
        
        self._date = date

    @property
    def mail_count(self):
        """
        Gets the mail_count of this Report.
        the number of recipients reached on this day

        :return: The mail_count of this Report.
        :rtype: int
        """
        return self._mail_count

    @mail_count.setter
    def mail_count(self, mail_count):
        """
        Sets the mail_count of this Report.
        the number of recipients reached on this day

        :param mail_count: The mail_count of this Report.
        :type: int
        """
        
        self._mail_count = mail_count

    @property
    def opens(self):
        """
        Gets the opens of this Report.
        the number of opens on this day

        :return: The opens of this Report.
        :rtype: int
        """
        return self._opens

    @opens.setter
    def opens(self, opens):
        """
        Sets the opens of this Report.
        the number of opens on this day

        :param opens: The opens of this Report.
        :type: int
        """
        
        self._opens = opens

    @property
    def unique_opens(self):
        """
        Gets the unique_opens of this Report.
        the number of unique opens on this day

        :return: The unique_opens of this Report.
        :rtype: int
        """
        return self._unique_opens

    @unique_opens.setter
    def unique_opens(self, unique_opens):
        """
        Sets the unique_opens of this Report.
        the number of unique opens on this day

        :param unique_opens: The unique_opens of this Report.
        :type: int
        """
        
        self._unique_opens = unique_opens

    @property
    def clicks(self):
        """
        Gets the clicks of this Report.
        the number of clicks on this day

        :return: The clicks of this Report.
        :rtype: int
        """
        return self._clicks

    @clicks.setter
    def clicks(self, clicks):
        """
        Sets the clicks of this Report.
        the number of clicks on this day

        :param clicks: The clicks of this Report.
        :type: int
        """
        
        self._clicks = clicks

    @property
    def unique_clicks(self):
        """
        Gets the unique_clicks of this Report.
        the number of unique clicks on this day

        :return: The unique_clicks of this Report.
        :rtype: int
        """
        return self._unique_clicks

    @unique_clicks.setter
    def unique_clicks(self, unique_clicks):
        """
        Sets the unique_clicks of this Report.
        the number of unique clicks on this day

        :param unique_clicks: The unique_clicks of this Report.
        :type: int
        """
        
        self._unique_clicks = unique_clicks

    @property
    def conversions(self):
        """
        Gets the conversions of this Report.
        the number of conversions on this day

        :return: The conversions of this Report.
        :rtype: int
        """
        return self._conversions

    @conversions.setter
    def conversions(self, conversions):
        """
        Sets the conversions of this Report.
        the number of conversions on this day

        :param conversions: The conversions of this Report.
        :type: int
        """
        
        self._conversions = conversions

    @property
    def sum_conversions(self):
        """
        Gets the sum_conversions of this Report.
        the amount recipients spent on this day

        :return: The sum_conversions of this Report.
        :rtype: int
        """
        return self._sum_conversions

    @sum_conversions.setter
    def sum_conversions(self, sum_conversions):
        """
        Sets the sum_conversions of this Report.
        the amount recipients spent on this day

        :param sum_conversions: The sum_conversions of this Report.
        :type: int
        """
        
        self._sum_conversions = sum_conversions

    @property
    def unsubscribes(self):
        """
        Gets the unsubscribes of this Report.
        the number of unsubscribes on this day

        :return: The unsubscribes of this Report.
        :rtype: int
        """
        return self._unsubscribes

    @unsubscribes.setter
    def unsubscribes(self, unsubscribes):
        """
        Sets the unsubscribes of this Report.
        the number of unsubscribes on this day

        :param unsubscribes: The unsubscribes of this Report.
        :type: int
        """
        
        self._unsubscribes = unsubscribes

    @property
    def hard_bounces(self):
        """
        Gets the hard_bounces of this Report.
        the number of hard_bounces on this day

        :return: The hard_bounces of this Report.
        :rtype: int
        """
        return self._hard_bounces

    @hard_bounces.setter
    def hard_bounces(self, hard_bounces):
        """
        Sets the hard_bounces of this Report.
        the number of hard_bounces on this day

        :param hard_bounces: The hard_bounces of this Report.
        :type: int
        """
        
        self._hard_bounces = hard_bounces

    @property
    def soft_bounces(self):
        """
        Gets the soft_bounces of this Report.
        the number of soft_bounces on this day

        :return: The soft_bounces of this Report.
        :rtype: int
        """
        return self._soft_bounces

    @soft_bounces.setter
    def soft_bounces(self, soft_bounces):
        """
        Sets the soft_bounces of this Report.
        the number of soft_bounces on this day

        :param soft_bounces: The soft_bounces of this Report.
        :type: int
        """
        
        self._soft_bounces = soft_bounces

    @property
    def spam_bounces(self):
        """
        Gets the spam_bounces of this Report.
        the number of spam_bounces on this day

        :return: The spam_bounces of this Report.
        :rtype: int
        """
        return self._spam_bounces

    @spam_bounces.setter
    def spam_bounces(self, spam_bounces):
        """
        Sets the spam_bounces of this Report.
        the number of spam_bounces on this day

        :param spam_bounces: The spam_bounces of this Report.
        :type: int
        """
        
        self._spam_bounces = spam_bounces

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other

